/*
jGuard is a security framework based on top of jaas (java authentication and authorization security).
it is written for web applications, to resolve simply, access control problems.
version $Name$
http://sourceforge.net/projects/jguard/

Copyright (C) 2004  Charles GAY

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


jGuard project home page:
http://sourceforge.net/projects/jguard/

*/


package net.sf.jguard.core.authentication;

import java.security.Permission;
import javax.security.auth.Subject;



/**
 *
 * @author <a href="mailto:diabolo512@users.sourceforge.net">Charles Gay</a>
 */
public interface AuthenticationBindings {
    
    
   public void init(String location,String authenticationScope);
   
   //actions
   public void logonProcess (AccessContext context);
   public void logoff (AccessContext context); 
   public boolean authenticate(AccessContext context);
   public void process(AccessContext context);
   public void accessDenied(AccessContext context);
   public void redirectToLogon(AccessContext context);
   
   public Subject getSubject(AccessContext context);
   public Permission getPermissionRequested(AccessContext context);
   public void setLastAccessDeniedPermission(AccessContext context, Permission permission);
   
   //permissions
   public Permission getAuthenticationFailedPermission();
   public Permission getLogonPermission();
   public Permission getLogonProcessPermission();
   public Permission getLogoffPermission();
   public Permission getRegisterPermission();
   public Permission getRegisterProcessPermission();
   public Permission getIndexPermission();

   public void addAlwaysGrantedPermissionsToPolicy();

   /**
    * return a Context anonymizing the user present in it.
    * @param context
    * @return
    */
   public AccessContext anonymize(AccessContext context);

   public void registerProcess(AccessContext contxt);
  
}
